| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
cutlass::layout::TensorNCxHWx< Interleave > Class Template Reference

Mapping function for 4-D NC/xHWx tensors.

`#include <tensor.h>`

## Public Types
using | Index = int32_t
| Index type used for coordinates. More...
using | LongIndex = int64_t
| Long index type used for offsets. More...
using | TensorCoord = Tensor4DCoord
| Logical coordinate. More...
using | Stride = Coord< kStrideRank >
| Stride vector. More...

## Public Member Functions
CUTLASS_HOST_DEVICE | TensorNCxHWx (Stride const &stride=Stride(0))
| Constructor. More...
CUTLASS_HOST_DEVICE LongIndex | operator() (TensorCoord const &coord) const
| Returns the offset of a coordinate in linear memory. More...
CUTLASS_HOST_DEVICE Stride | stride () const
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Stride & | stride ()
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE LongIndex | capacity (TensorCoord const &extent) const
| Compute the number of contiguous elements needed to store a tensor with the given size. More...

## Static Public Member Functions
static CUTLASS_HOST_DEVICE TensorNCxHWx | packed (TensorCoord const &extent)
| Helper returns a layout to a tightly packed tensor. More...

## Static Public Attributes
static int const | kInterleave = Interleave
| Interleaving quantity. More...
static int const | kRank = 4
| Logical rank of tensor. More...
static int const | kStrideRank = 3
| Rank of stride vector. More...

## Member Typedef Documentation

template<int Interleave>

using cutlass::layout::TensorNCxHWx< Interleave >::Index = int32_t

template<int Interleave>

using cutlass::layout::TensorNCxHWx< Interleave >::LongIndex = int64_t

template<int Interleave>

using cutlass::layout::TensorNCxHWx< Interleave >::Stride = Coord<kStrideRank>

template<int Interleave>

using cutlass::layout::TensorNCxHWx< Interleave >::TensorCoord = Tensor4DCoord

## Constructor & Destructor Documentation

template<int Interleave>

CUTLASS_HOST_DEVICE cutlass::layout::TensorNCxHWx< Interleave >::TensorNCxHWx | ( | Stride const & | stride = `Stride(0)` | ) |
| inline

## Member Function Documentation

template<int Interleave>

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::TensorNCxHWx< Interleave >::capacity | ( | TensorCoord const & | extent | ) | const
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::TensorNCxHWx< Interleave >::operator() | ( | TensorCoord const & | coord | ) | const
| inline

template<int Interleave>

static CUTLASS_HOST_DEVICE TensorNCxHWx cutlass::layout::TensorNCxHWx< Interleave >::packed | ( | TensorCoord const & | extent | ) |
| inline static

template<int Interleave>

CUTLASS_HOST_DEVICE Stride cutlass::layout::TensorNCxHWx< Interleave >::stride | ( |  | ) | const
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE Stride& cutlass::layout::TensorNCxHWx< Interleave >::stride | ( |  | ) |
| inline

## Member Data Documentation

template<int Interleave>

int const cutlass::layout::TensorNCxHWx< Interleave >::kInterleave = Interleave
| static

template<int Interleave>

int const cutlass::layout::TensorNCxHWx< Interleave >::kRank = 4
| static

template<int Interleave>

int const cutlass::layout::TensorNCxHWx< Interleave >::kStrideRank = 3
| static

The documentation for this class was generated from the following file:

- tensor.h